# 🔐 Security Policy

## 📦 Supported Versions

We actively maintain and provide security updates for the following versions of this project:

| Version | Supported          |
|---------|--------------------|
| > 0.5.x   | ✅ Supported        |
| < 0.5.0   | ❌ Not supported    |

If you're using an older version, we strongly recommend upgrading to the latest stable release to receive the latest security patches and improvements.

---

## 📣 Reporting a Vulnerability

We take security seriously and appreciate your help in keeping the project safe for everyone.

If you discover a vulnerability or security issue, please report it **privately** by following these steps:

1. **Email us at:** [elena.de.la.fuente.garcia@cern.ch] 
2. Please include:
   - A detailed description of the issue
   - Steps to reproduce (if applicable)
   - Potential impact or exploit scenario

We’ll respond as quickly as possible — typically within **2–3 business days**. If the report is valid, we’ll work with you to coordinate a fix and public disclosure.

---

## 🤝 Responsible Disclosure

We follow a **responsible disclosure policy**:
- Fixes are prioritized and developed privately.
- Public disclosure only happens after a patch has been released.
- Credit will be given to security researchers upon request. 🙏

---

Thank you for helping us keep the project secure and reliable! 🛡️
